package exnihilocreatio.items;

import exnihilocreatio.ExNihiloCreatio;
import exnihilocreatio.ModFluids;
import exnihilocreatio.util.Data;
import exnihilocreatio.util.IHasModel;
import net.minecraft.client.renderer.block.model.ModelBakery;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.monster.EntityBlaze;
import net.minecraft.entity.monster.EntityEnderman;
import net.minecraft.entity.monster.EntityGuardian;
import net.minecraft.entity.monster.EntityShulker;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.ArrayList;
import java.util.List;

public class ItemDoll extends Item implements IHasModel {

    public static final String BLAZE = "blaze"; // 0
    public static final String ENDERMAN = "enderman"; // 1
    public static final String SHULKER = "shulker"; // 2
    public static final String GUARDIAN = "guardian"; // 3

    private static ArrayList<String> names = new ArrayList<String>();

    public ItemDoll() {
        super();
        func_77655_b("item_doll");
        setRegistryName("item_doll");

        func_77637_a(ExNihiloCreatio.tabExNihilo);
        func_77627_a(true);

        names.add(BLAZE);
        names.add(ENDERMAN);
        names.add(SHULKER);
        names.add(GUARDIAN);

        Data.ITEMS.add(this);
    }

    public Fluid getSpawnFluid(ItemStack stack) {
        switch (stack.func_77960_j()) {
            case 0:
                return FluidRegistry.LAVA;
            case 3:
                return FluidRegistry.WATER;
            default:
                return ModFluids.fluidWitchwater;
        }
    }

    /**
     * Spawns the mob in the world at position
     *
     * @param stack The Doll Stack
     * @param pos   Blockpos
     * @return true if spawn is successful
     */
    public boolean spawnMob(ItemStack stack, World world, BlockPos pos) {
        switch (stack.func_77960_j()){
            case 0:
                EntityBlaze blaze = new EntityBlaze(world);
                blaze.func_70107_b(pos.func_177958_n(), pos.func_177956_o() + 1, pos.func_177952_p());

                return world.func_72838_d(blaze);
            case 1:
                EntityEnderman enderman = new EntityEnderman(world);
                enderman.func_70107_b(pos.func_177958_n(), pos.func_177956_o() + 2, pos.func_177952_p());

                return world.func_72838_d(enderman);
            case 2:
                EntityShulker shulker = new EntityShulker(world);
                shulker.func_70107_b(pos.func_177958_n(), pos.func_177956_o() + 1.5, pos.func_177952_p());

                return world.func_72838_d(shulker);
            case 3:
                EntityGuardian guardian = new EntityGuardian(world);
                guardian.func_70107_b(pos.func_177958_n(), pos.func_177956_o() + 1, pos.func_177952_p());

                return world.func_72838_d(guardian);
            default:
                return false;
        }
    }

    @Override
    @Nonnull
    public String func_77667_c(ItemStack stack) {
        return func_77658_a() + "." + names.get(stack.func_77952_i());
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_150895_a(@Nullable CreativeTabs tab, NonNullList<ItemStack> list) {
        if (this.func_194125_a(tab))
            for (int i = 0; i < names.size(); i++)
                list.add(new ItemStack(this, 1, i));
    }

    @SideOnly(Side.CLIENT)
    @Override
    public void initModel(ModelRegistryEvent event) {

//        for (int i = 0; i < names.size(); i++) {
//            String variant = "type=" + names.get(i);
//            ModelLoader.setCustomModelResourceLocation(this, i, new ModelResourceLocation("exnihilocreatio:itemDoll", variant));
//        }

         List<ModelResourceLocation> locations = new ArrayList<>();
        for (String name : names) {
            locations.add(new ModelResourceLocation(getRegistryName(), "type=" + name));
        }

         ModelBakery.registerItemVariants(this, locations.toArray(new ModelResourceLocation[0]));
         ModelLoader.setCustomMeshDefinition(this, stack -> locations.get(stack.func_77960_j()));

    }

}
